
{$APPTYPE GUI}{$MODE DELPHI}

program demo41;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Collision;

//const
 
//type
  
var  
  anim:glfloat;
  TexPallone:gluint;
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
end; 


procedure Stencil;
begin
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
end;


procedure Liquido;
begin
  TextureSelectID(0);
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
end;


procedure Scena;
begin
  // terreno
  TextureSelectID(1);
  glPushMatrix; 
  glTranslatef(0,-5,0);   
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glPopMatrix;
  
  // palla
  glCallList(TexPallone);
  glPushMatrix;   
  glTranslatef(0,sin(anim)/2,0);   
  Sfera(0,0,0, 1, 32,32, 1);
  glPopMatrix; 
  
  // tronco gallegiante
  TextureSelectID(2);  
  glPushMatrix; 
  glTranslatef(5,-0.4+cos(anim)/6,3); 
  glRotatef(25,0,1,0);    
  glRotatef(180+5+sin(anim)*3,1,0,0);   
  Cilindro(0,0,0, 1,32, 0.5,4, 1);  
  glPopMatrix; 
  
  // palo inclinato
  glPushMatrix; 
  glTranslatef(5,-5,-6); 
  glRotatef(45,0,1,0);   
  glRotatef(180+96,1,0,0);   
  Cilindro(0,0,0, 1,32, 0.4,7, 1);  
  glPopMatrix;  
  
  // palo verticale
  glPushMatrix; 
  glTranslatef(-5,-5,6);   
  glRotatef(180+90,1,0,0);   
  Cilindro(0,0,0, 1,32, 0.4,7, 1);  
  glPopMatrix;   
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('water4.bmp',0);
  TextureLoadID('Floor04.bmp',1);  
  TextureLoadID('corteccia01.bmp',2);
  
end;
begin 

  OpenGL_Texture();

  TexPallone :=glGenLists(1);
  glNewList(TexPallone, GL_COMPILE);
  
  TextureQuadWaves(1,0.5,0.1, 2,1,false); 
  
  glEndList;
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 
  
  anim:=anim+0.25;
  
  FX_Refraction(GL_CLIP_PLANE0, 0,0,0, 0,0,0, 1,0.6,1,stencil,Liquido,scena);  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Indice di rifrazione in un liquido', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
